<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>mixins</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>

<body>
    <script>
        // define a mixin object
        var myMixin = {
            created: function () {
                this.hello()
            },
            methods: {
                hello: function () {
                    console.log('hello from mixin!')
                }
            }
        }

        // define a component that uses this mixin
        var Component = Vue.extend({
            mixins: [myMixin]
        })

        var component = new Component() // => "hello from mixin basic!"
    </script>


    <!-- Option Merging  -->
    <script>
        var mixin = {
            data: function () {
                return {
                    message: 'hello',
                    foo: 'abc'
                }
            }
        }

        new Vue({
            mixins: [mixin],
            data: function () {
                return {
                    message: 'goodbye',
                    bar: 'def'
                }
            },
            created: function () {
                console.log(this.$data)
                // => { message: "goodbye", foo: "abc", bar: "def" }
            }
        })

        // hook
        var mixin = {
            created: function () {
                console.log('hook trong mixin sẽ được gọi trước')
            }
        }

        new Vue({
            mixins: [mixin],
            created: function () {
                console.log('sau đó đến hook của component')
            }
        })

        // object value
        var mixin = {
            methods: {
                foo: function () {
                    console.log('foo')
                },
                conflicting: function () {
                    console.log('from mixin')
                }
            }
        }

        var vm = new Vue({
            mixins: [mixin],
            methods: {
                bar: function () {
                    console.log('bar')
                },
                conflicting: function () {
                    console.log('from self')
                }
            }
        })

        vm.foo() // => "foo"
        vm.bar() // => "bar"
        vm.conflicting() // => "from self"
    </script>
    
    <!-- Global Mixin -->
    <script>
        // inject a handler for `myOption` custom option
        Vue.mixin({
            created: function () {
                var myOption = this.$options.myOption
                if (myOption) {
                    console.log(myOption)
                }
            }
        })

        new Vue({
            myOption: 'hello Global Mixin!'
        })
// => "hello!"
    </script>
</body>

</html>